version: 1

secrets:
  pg-credentials:
    string_data:
      username: nirvati
      password: {{ derive_entropy(identifier="db_password") }}
      uri: postgresql://nirvati:{{ derive_entropy(identifier="db_password") }}@postgres.nirvati.svc.cluster.local:5432/nirvati

services:
  dns:
    ports:
      udp:
        53: 53
    type: ClusterIp
    cluster_ip: 10.43.0.11
    target_container: dns
  agent-public:
    ports:
      tcp:
        8081: 8081
    type: ClusterIp
    target_container: agent
    network_policy:
      allow_cluster:
        allow: true
        allowed_ports:
          - port: 8081
            protocol: Tcp

ingress:
  - target_svc: longhorn-frontend
    target_ns: longhorn-system
    port: 80
    path_prefix: /longhorn
  - target_svc: main
    port: 3000
    path_prefix: /api/_nuxt_icon
    strip_prefix: false
    
    
containers:
  main:
  {% if installed_apps is containing("citadel-system-wide") %}
    image: harbor.nirvati.org/nirvati/dashboard-citadel:v0-1-22
  {% else %}
    image: harbor.nirvati.org/nirvati/dashboard:v0-1-22
  {% endif %}
    ingress_port: 3000
  api:
    image: harbor.nirvati.org/nirvati/api:v0.1.25
    ingress_port: 80
    environment:
      DATABASE_URL:
        secret: pg-credentials
        key: uri
      BIND_ADDRESS: "[::]:80"
      AGENT_ENDPOINT: http://agent.nirvati.svc.cluster.local:8080
      JWT_SECRET: {{ derive_entropy(identifier="jwt_secret") }}
      APPS_DIR: /apps
      LONGHORN_ENDPOINT: http://longhorn-backend.longhorn-system.svc.cluster.local:9500
      REDIS_URL: redis://valkey.nirvati.svc.cluster.local:6379
    path_prefix: /api
    mounts:
      data:
        apps: /apps
    service_account:
      cluster_rules:
      - apiGroups: ['']
        resources: ['persistentvolumeclaims']
        verbs: ['get', 'list']
      rules:
      - apiGroups: ['']
        resources: ['secrets']
        verbs: ['get', 'create']
    network_policy:
      ingress:
        allow_same_ns: true
      egress:
        allow_same_ns: true
        allow_world: true
        services:
          - namespace: longhorn-system
            service_name: longhorn-backend
        allow_kube_api: true
        dns:
          allow: true
  updater:
    image: harbor.nirvati.org/nirvati/bg-updater:v0.1.25
    schedule: "0 * * * *"
    restart: on-failure
    environment:
      DATABASE_URL:
        secret: pg-credentials
        key: uri
      AGENT_ENDPOINT: http://agent.nirvati.svc.cluster.local:8080
  agent:
    image: harbor.nirvati.org/nirvati/agent:v0.1.25
    entrypoint: /nirvati-agent
    internal_ports:
      tcp:
        8080: 8080
    environment:
      TAILSCALE_SOCKET: /tailscale/tailscaled.sock
      APPS_PATH: /apps
      NIRVATI_APP_STORE_VERSION: stable
      RUST_LOG: "debug"
      # This secret is initialized by init
      NIRVATI_SEED:
        secret: nirvati-seed
        key: seed
    mounts:
      host_paths:
        /var/run/tailscale: /tailscale
      data:
        apps: /apps
    service_account:
      cluster_rules:
      - apiGroups: ['*']
        resources: ['*']
        verbs: ['*']
      - nonResourceURLs: ['*']
        verbs: ['*']
    network_policy:
      ingress:
        allow_same_ns: true
      egress:
        allow_same_ns: true
        allow_world: true
        allow_cluster: true
        allow_kube_api: true
        dns:
          allow: true
  postgres:
    image: ghcr.io/ferretdb/postgres-documentdb:16.6-0.100-0
    internal_ports:
      tcp:
        5432: 5432
    mounts:
      data:
        db/postgres: /var/lib/postgresql/data
    environment:
      POSTGRES_USER:
        secret: pg-credentials
        key: username
      POSTGRES_PASSWORD:
        secret: pg-credentials
        key: password
    network_policy:
      ingress:
        allow_same_ns: true
      egress:
        allow_same_ns: false
        allow_world: false
        dns:
          allow: false
  migrations:
    image: harbor.nirvati.org/nirvati/migrations:v0.1.25
    job_type: OnUpdate
    restart: on-failure
    service_account:
      cluster_rules:
      - apiGroups: ['*']
        resources: ['*']
        verbs: ['*']
      - nonResourceURLs: ['*']
        verbs: ['*']
    environment:
      NIRVATI_SEED:
        secret: nirvati-seed
        key: seed
      DATABASE_URL:
        secret: pg-credentials
        key: uri
      APPS_DIR: /apps
    mounts:
      data:
        apps: /apps
  dns:
    image: harbor.nirvati.org/nirvati/dns:v0.1.25
    mounts:
      data:
        apps: /apps
    environment:
      DATABASE_URL:
        secret: pg-credentials
        key: uri
    service_account:
      cluster_rules:
      - apiGroups: ['']
        resources: ['services']
        verbs: ['get']
  valkey:
    image: valkey/valkey:8.0.1
    internal_ports:
      tcp:
        6379: 6379
  adminer:
    image: adminer
    ingress_port: 8080
    path_prefix: /adminer
